#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum LineStyleV1 {
    #[serde(rename = "SOLID")]
    Solid,
    #[serde(rename = "DASH")]
    Dash,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl LineStyleV1 {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            LineStyleV1::Solid => "SOLID",
            LineStyleV1::Dash => "DASH",
            LineStyleV1::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for LineStyleV1 {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for LineStyleV1 {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for LineStyleV1 {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<LineStyleV1, conjure_object::plain::ParseEnumError> {
        match v {
            "SOLID" => Ok(LineStyleV1::Solid),
            "DASH" => Ok(LineStyleV1::Dash),
            v => v.parse().map(|v| LineStyleV1::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for LineStyleV1 {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<LineStyleV1, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the LineStyleV1 enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
